# User Guide

:::{admonition} Work in Progress
:class: warning

The user guide is a work in progress. If you have any questions or suggestions, please feel free to open an issue on [GitHub](https://github.com/kmnhan/erlabpy/issues).

For the full list of packages and modules, see [](../reference.md).

:::

## Introduction

Welcome to the `erlab` user guide! This guide provides an overview of `erlab` and its core features.

If you are new to `erlab`, you may want to start with the [getting started guide](../getting-started.md).

```{toctree}
:caption: Table of Contents
:maxdepth: 2

imagetool
io
indexing
plotting
kconv
curve-fitting
filtering
```

## Further reading

- [Lectures on scientific computing with Python](https://github.com/jrjohansson/scientific-python-lectures)
- [The beginner's guide to numpy](https://numpy.org/doc/stable/user/absolute_beginners.html)
- [Xarray tutorial](https://tutorial.xarray.dev/)
